//-----------------------------------------
// LW2Backburner
//-----------------------------------------

@version 2.4
@warnings
@script generic
@name LW2Backburner

// ------------------------------------------------
// GLOBAL VARIABLES:
// ------------------------------------------------

        // infos, that are given by the user
    Name, Project, ProjectName, SceneNumber, Sequence, Type, FrameStepI, FrameStepF, Pass, Description, FramesPerCPU, MultiThread, RenderGroupList, RenderGroupID, Priority;

        // infos, that are calculated by the function CalculateNamesAndFolders()
    SceneName, ScenePath, Version , OutImagesFolder, OutImagesName;

        // ctls
    ctl_NewSceneName, ctl_NewScenePath, ctl_Version, ctl_OutRGB, ctl_Name, ctl_Project, ctl_SceneNumber, ctl_SequNumber, ctl_Type, ctl_Pass;

        // others
    TypeList;



//-----------------------------------------------
//Generic Function
//-----------------------------------------------

generic
{
// define InfoLists (START)
    RenderGroupList[1] = "";


    TypeList[1] = "Rendering";
    TypeList[2] = "SFX";
    TypeList[3] = "Animation";
    TypeList[4] = "Development";

    Project = getdir(CONTENTDIR);

// default settings
    Name = "NoName";
    Sequence = "";
    SceneNumber = "";
    TypeNumber = 1;
    Type = TypeList[TypeNumber];
    Version = 0;
    ProjectName="";

// Change default settings according to current Scene Name
    
    SplittedProjectName=split(Project);
    ProjectName=SplittedProjectName[2];

    CurrentSceneName = Scene().filename;

    if (CurrentSceneName != "(unnamed)")        // take settings from the current Scene Name
    {
        SplittedSceneName = split(CurrentSceneName);
        OnlyName = SplittedSceneName[3];

        // in case, it`s not a PP_Saver file, Name is first word behind "_"
        Name = SplittedSceneName[3];
        if (false)//(OnlyName.size() > 5)
        {
            // first check, if it`s a version number
            if ( (number(strright(OnlyName, 3)) != (nil) ) && (OnlyName[OnlyName.size() - 4] == "_") && (OnlyName[OnlyName.size() - 3] == "v") )
                OnlyName = strleft(OnlyName, OnlyName.size() - 5);

            ParsedSceneName = parse("_", OnlyName);
            Type = ParsedSceneName[ParsedSceneName[1]];

            TypeNumber = -1;
            for (i = 1; i <= TypeList.size(); i++)
                if (Type == TypeList[i])
                    TypeNumber = i;
            
            if (TypeNumber != -1)
            {
                Pass = ParsedSceneName[ParsedSceneName.size()];
                Name = ParsedSceneName[ParsedSceneName.size() - 1];
                SceneNumber = "";
                if (ParsedSceneName.size() > 2)
               SceneNumber = ParsedSceneName[3];
                Sequence = "";
                if (ParsedSceneName.size() > 3)
                    Sequence = ParsedSceneName[2];
            }
        }
    }

    CalculateNamesAndFolders();

// Create CTLs
    reqbegin("LW2Backburner");
    reqsize(520,300);

    ctl_Name = ctlstring("Name   ", Name);                                  ctlposition(ctl_Name,20,60,200,20);
    ctl_Project = ctlstring("Project ",Project);                            ctlposition(ctl_Project,20,90,200,20);
    ctl_SequNumber = ctlstring("Sequence",Sequence);                        ctlposition(ctl_SequNumber,20,500,142,20);

    ctl_SceneNumber = ctlstring("SceneNumber",SceneNumber);                 ctlposition(ctl_SceneNumber,170,500,152,20);
    ctl_Type = ctlpopup("Type",TypeNumber,TypeList);                        ctlposition(ctl_Type,20,500,142,19);

    ctl_SepNewNames = ctlsep(311,288);                                      ctlposition(ctl_SepNewNames,20,150,480,5);

    ctl_NewSceneName = ctlstring("SceneName", SceneName);                   ctlposition(ctl_NewSceneName, 20,500,280,20); 
    ctl_NewScenePath = ctlstring("FilePath", ScenePath);                    ctlposition(ctl_NewScenePath, 20,500,280,20); 
    ctl_Version = ctlstring("FileVersion", "not saved yet");                ctlposition(ctl_Version, 20,500,280,20); 
    if (Version > 0)
        setvalue(ctl_Version, string(Version));
    ctl_OutRGB = ctlstring("OutRGB", OutImagesName);                        ctlposition(ctl_OutRGB, 20, 120, 480, 20);
    ctl_SepTabs = ctlsep(311,289);                                          ctlposition(ctl_SepTabs,20,45,480,5);
    button_About = ctlbutton("about",80,"infobutton_callback");             ctlposition(button_About,230,15);

    CheckBox_AddToRenderQueue = ctlcheckbox("Add to render Queue",1);       ctlposition(CheckBox_AddToRenderQueue,20,180);
    ctl_Pass = ctlstring("Pass", Pass);                                     ctlposition(ctl_Pass,20,500,135,19);
    ctl_Priority = ctlinteger("Priority      ",50);                         ctlposition(ctl_Priority,20,210,90,18);
    ctl_FramesPerCPU = ctlinteger("frames per CPU", 1);                     ctlposition(ctl_FramesPerCPU,123,210,122,19);

    ctl_StartFrame = ctlinteger("start frame",Scene().renderstart);         ctlposition(ctl_StartFrame,20,240,100,20);
    ctl_FrameStep = ctlinteger("frame step",Scene().renderstep);            ctlposition(ctl_FrameStep,300,240,101,20);
    ctl_EndFrame = ctlinteger("end frame",Scene().renderend);               ctlposition(ctl_EndFrame,150,240,94,22);
    ctl_SepRender = ctlsep(311,288);                                        ctlposition(ctl_SepRender,20,500,480,5);


    CheckBox_MultiThread = ctlcheckbox("Run Multithread",1);                ctlposition(CheckBox_MultiThread,300,210);
    ctl_Description = ctlstring("description","");                          ctlposition(ctl_Description,20,500,280,19);
    ctl_RenderGroups = ctlpopup("RenderGroup  ",1,RenderGroupList);         ctlposition(ctl_RenderGroups,20,500,200,18);

// TabSetups
    ctl_Tab = ctltab("Setup Backburner");
    ctlposition(ctl_Tab,10,15);
    ctlpage(1,ctl_Project,ctl_Name,ctl_Type,ctl_SequNumber,ctl_SceneNumber, ctl_NewSceneName, ctl_NewScenePath, ctl_Version, ctl_OutRGB, ctl_SepNewNames,ctl_StartFrame,ctl_FrameStep, ctl_EndFrame, ctl_SepRender,CheckBox_AddToRenderQueue,ctl_Priority,ctl_FramesPerCPU,
            ctl_Pass,CheckBox_MultiThread,ctl_Description,ctl_RenderGroups);


// Layout Events
    ctlactive(ctl_Type,"IfDevelopment",ctl_SequNumber);
    ctlactive(ctl_Type,"IfDevelopment",ctl_SceneNumber);

    ctlrefresh(ctl_Name,"RefreshSceneName");
    ctlrefresh(ctl_Project,"RefreshSceneName");
    ctlrefresh(ctl_SequNumber,"RefreshSceneName");
    ctlrefresh(ctl_SceneNumber,"RefreshSceneName");
    ctlrefresh(ctl_Type,"RefreshSceneName");    
    ctlrefresh(ctl_Pass,"RefreshSceneName");
    ctlrefresh(ctl_NewSceneName,"RefreshSceneName");
    ctlrefresh(ctl_NewScenePath,"RefreshSceneName");
    ctlrefresh(ctl_Version,"RefreshSceneName");
    ctlrefresh(ctl_OutRGB,"RefreshSceneName");

    ctlactive(CheckBox_AddToRenderQueue,"IfRender",ctl_OutRGB);
    ctlactive(CheckBox_AddToRenderQueue,"IfRender",ctl_Pass);
    ctlactive(CheckBox_AddToRenderQueue,"IfRender",ctl_Priority);
    ctlactive(CheckBox_AddToRenderQueue,"IfRender",ctl_FramesPerCPU);
    ctlactive(CheckBox_AddToRenderQueue,"IfRender",ctl_StartFrame);
    ctlactive(CheckBox_AddToRenderQueue,"IfRender",ctl_EndFrame);
    ctlactive(CheckBox_AddToRenderQueue,"IfRender",ctl_FrameStep);
    ctlactive(CheckBox_AddToRenderQueue,"IfRender",ctl_Description);
    ctlactive(CheckBox_AddToRenderQueue,"IfRender",ctl_RenderGroups);
    ctlactive(CheckBox_AddToRenderQueue,"IfRender",CheckBox_MultiThread);

    
// if OK is pressed
    if(reqpost())
    {
        if(getvalue(CheckBox_AddToRenderQueue) == 0)
        {
        }
        else
        {
            FirstFrame(getvalue(ctl_StartFrame));
            LastFrame(getvalue(ctl_EndFrame));
            FrameStep(getvalue(ctl_FrameStep));

            Pass = getvalue(ctl_Pass);

            RenderGroupID = getvalue(ctl_RenderGroups);
            Priority  = getvalue(ctl_Priority);
            FramesPerCPU = getvalue(ctl_FramesPerCPU);
            Description = getvalue(ctl_Description);

            CalculateNamesAndFolders;

            SetupBackburner();
        }
    }
}


//-------------------------------------------------------------------------------------------
//CalculateNamesAndFolders
// Updates these Global Variables: ScenePath, SceneName, Version, OutImagesFolder and OutImagesName
//-------------------------------------------------------------------------------------------
CalculateNamesAndFolders
{
    // first createing SequenceWithBack, SequenceWithUnder, SceneNumberWithBack, SceneNumberWithUnder..
    // (they are used for quicker FileName-createing in the following functions)
    if ((Sequence.size() > 0) && (Type != "Development"))
    {
        SequenceWithBack = Sequence + "\\";
        SequenceWithUnder = Sequence + "_";
    }
    else
    {
        SequenceWithBack = "";
        SequenceWithUnder = "";
    }
    if (Type != "Development")
    {
        SceneNumberWithBack = SceneNumber + "\\";
        SceneNumberWithUnder = SceneNumber + "_";
    }
    else
    {
        SceneNumberWithBack = "";
        SceneNumberWithUnder = "";
    }

    ScenePath = Project + "\\Scenes\\" + Type + "\\" + SequenceWithBack + SceneNumberWithBack + Name;
    SceneName = Type + "_" + SequenceWithUnder + SceneNumberWithUnder + Name + "_" + Pass + ".lws";

    Files = matchfiles(ScenePath, "*.lws");
    Version = Files.size();
    Files = matchfiles(ScenePath + "\\History", "*.lws");
    Version += Files.size();

    if ( (Pass == "") || (Pass == (nil)) )
        Pass = "Default";

    OutImagesFolder="";
    OutImagesName = Scene().rgbprefix;
}


//-----------------------------------------------------
//SaveSceneAndCreateBackup
// if inRender is 1 then he also renders
//-----------------------------------------------------
SaveSceneAndCreateBackup : inRender
{
    CalculateNamesAndFolders;

    mkdirResult = spawn("cmd /c mkdir " + ScenePath + "\\History");
    VersionString = "v" + Version.asStr(3,true);
    
    existingFiles = matchfiles(ScenePath,"*.lws");
    if (existingFiles.size() > 0)
    {
        existingFile = existingFiles[1];
        spawn("cmd /c xcopy /y /v " + ScenePath + "\\" + SceneName + " " + ScenePath + "\\History");
        newBackupFileName = strsub(SceneName,1,SceneName.size() - 4) + "_" + VersionString + ".lws";
        spawn("cmd /c rename " + ScenePath + "\\History\\" + SceneName + " " + newBackupFileName);
    }

    if (inRender)   // updates OutRGB-Images in the Lightwave RenderSettings
    {
        mkdirResult = spawn("cmd /c mkdir " + OutImagesFolder);
        input = "SaveRGBPrefix " + OutImagesFolder + "\\" + OutImagesName;
        CommandInput(input);
    }
    SaveSceneAs(ScenePath + "\\" + SceneName);
    
}



//-------------------------------------
//Setup Backburner
//-------------------------------------
SetupBackburner
{
    //JobFolder = OutImagesFolder + "\\Job";
    JobFolder = Project + "\\Job";
    LogFolder = JobFolder + "\\Log";
    spawn("cmd /c mkdir \"" + LogFolder + "\"");

    FileInfoList = split(Scene().filename); 

    JobFile = fullpath(JobFolder + "\\" + FileInfoList[3] + "_Job.bat");
    FrameFile = fullpath(JobFolder + "\\" + FileInfoList[3] + "_Frames.txt");

    TaskNumbers = ceil(((Scene().renderend - Scene().renderstart)+1) / integer(FramesPerCPU));

    if (Description.size() == 0)
        Description = FileInfoList[3];

    JobFileArray[1] = "\"c:\\Program Files (x86)\\Autodesk\\Backburner\\cmdjob.exe\"";
    JobFileArray[1] += " -jobName \"" + FileInfoList[3] + "\"";
    JobFileArray[1] += " -manager 192.168.52.1";
    JobFileArray[1] += " -priority " + Priority;
    JobFileArray[1] += " -description \"" + Description + "\"";
    JobFileArray[1] += " -taskList \"" + FrameFile + "\"";
    JobFileArray[1] += " -timeout 200";
    JobFileArray[1] += " -taskName 1";
    JobFileArray[1] += " -group \"" + RenderGroupList[RenderGroupID] + "\"";
    JobFileArray[1] += " -logPath \"" + LogFolder + "\"";
    JobFileArray[1] += " -attach \"C:\\LW2Backburner.bat\" -d\"" + Project + "\"" + " " + "\"" + Project + "\\scenes\\"+ Name + ".lws\" %%tp2 %%tp3";
    writef(JobFileArray, JobFile);
    
    for(i = 0 ; i <= (Scene().renderend - Scene().renderstart) / FramesPerCPU  ; i++)
    {
    FrameStepI = Scene().renderstart + i*FramesPerCPU;
    FrameStepF = Scene().renderstart + i*FramesPerCPU + FramesPerCPU - 1;
    FrameFileArray[i+1]="Frames " + FrameStepI + "-" + FrameStepF + "\t" + FrameStepI + "\t" +  FrameStepF;
    }
    writef(FrameFileArray,FrameFile);

    spawn(JobFile);
}

//-------------------------------------------------------
// writing a file
//-------------------------------------------------------
writef: expr,outfile
{
    SCpar = File(outfile,"w") || error("Cannot open file",file,"'");
    SCpar.open(outfile,"w");
    for(i = 1;i <= expr.size();i++)
    {
        SCpar.writeln(expr[i]); 
    }
    SCpar.close();
}


//-------------------------------------
//CTL FUNCTIONS
//-------------------------------------
    RefreshSceneName : value    // updates the ctls_NewSceneName, ctl_NewScenePath, ctl_Version and ctl_OutRGB
    {
        Name = getvalue(ctl_Name);
        SceneNumber = getvalue(ctl_SceneNumber);
        Project = getvalue(ctl_Project);
        Sequence = getvalue(ctl_SequNumber);
        Type = TypeList[getvalue(ctl_Type)];
        Pass = getvalue(ctl_Pass);
    
        CalculateNamesAndFolders();
    
        setvalue(ctl_NewSceneName,SceneName);
        setvalue(ctl_NewScenePath,ScenePath);
        if (Version == 0)
            setvalue(ctl_Version, "not saved yet");
        else
            setvalue(ctl_Version, string(Version));
        setvalue(ctl_OutRGB,OutImagesFolder);
    }
    
    IfDevelopment : value   // turns Sequence and SceneNumber on or off
    {
        return(value != 4); 
    }
    
    IfRender : value        // turns all render ctls on or off
    {
        return(value == 1); 
    }
    
    infobutton_callback
    {
        info("LW2Backburner");
    }





